# wanha - your pesky URL-guardian for IRC
# Copyright (C) 2006 Tommi Saviranta  <wnd@iki.fi>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA


package Scores;

use strict;
use warnings FATAL => 'all';
use diagnostics;

require "db.pl";


# 0: nick id
# 1: chan id
sub add($$)
{
	my ($nick_raw, $chan_raw) = @_;
	my $query;

	my $nick = &DB::safe_string($nick_raw);
	my $chan = &DB::safe_string($chan_raw);

	$query = "INSERT INTO scoreboard (nick, chan) " .
			"VALUES ($nick, $chan)";
	&DB::update($query);
}


# 0: nick id
# 1: chan id
# 2: auto-add (define to enable)
# r: (fame, shame, cheat, wanha)
sub get($$$)
{
	my ($nick_raw, $chan_raw, $autoadd) = @_;
	my ($query, $result);

	my $nick = &DB::safe_string($nick_raw);
	my $chan = &DB::safe_string($chan_raw);

	$query = "SELECT fame, shame, cheat, wanha FROM scoreboard " .
			"WHERE nick = $nick AND chan = $chan";
	$result = &DB::query($query);
	if ($result->ntuples == 1) {
		my ($fame, $shame, $cheat, $wanha) = $result->fetchrow;
		return ($fame, $shame, $cheat, $wanha);
	} elsif ($result->ntuples == 0) {
		if (defined($autoadd) && $autoadd == 1) {
			&add($nick, $chan);
			return (0, 0, 0, 0);
		} else {
			return;
		}
	} else {
		printf STDERR "wanha:op_score.pl:get n=%d c=%d " .
				"returned %d matches",
				$nick_raw,
				$chan_raw,
				$result->ntuples;
		return;
	}
}
